<?php


function formulaires_telecharger_codes_postaux_charger() {
    include_spip('codes_postaux_config');
    $tab_objet = codes_postaux_config_tab_fichier();

    return array('tab_objet' => $tab_objet);
}


function formulaires_telecharger_codes_postaux_verifier_dist() {
    include_spip('codes_postaux_config');
    include_spip('inc/config');
    $erreurs = array();
    $tab_objet = codes_postaux_config_tab_fichier();
    sous_repertoire(_DIR_TMP, 'codes_postaux');

    if ($objet = _request('objet')) {
        if (!isset($tab_objet[$objet])) {
            $erreurs['message_erreur'] .= _T('codes_postaux:fichier_incorrect');
        }
    }

    return $erreurs;
}

function formulaires_telecharger_codes_postaux_traiter_dist() {
    include_spip('codes_postaux_config');
    include_spip('inc/codes_postaux_import');
    include_spip('inc/config');
    $tab_objet = codes_postaux_config_tab_fichier();
    $objet = _request('objet');
	$url_fichier = $tab_objet[$objet]['url_fichier'];
	$nom_fichier = '';
	if (!empty($url_fichier)) {
		$nom_fichier_txt = $tab_objet[$objet]['nom_fichier'] ?? '';
        $nom_fichier = codes_postaux_telecharger_fichier_distant($url_fichier, $nom_fichier_txt);
	}

    $retour['editable'] = true;
    if (!empty($nom_fichier) and $nom_fichier !== 'OK') {
        $retour['message_ok'] = _T('codes_postaux:telechargement_ok', array('fichier' => $tab_objet[$objet]['nom'] ?? $nom_fichier_txt));
    } else {
        $retour['message_erreur'] = _T('codes_postaux:telechargement_erreur');
    }
    return $retour;

}


function codes_postaux_telecharger_fichier_distant($source, $nom_fichier_txt = "") {
	include_spip('inc/distant');
	include_spip('inc/config');

	$fichier = copie_locale($source, 'force');
	if (file_exists(_DIR_RACINE . $fichier)) {
		$infos_fichier = pathinfo($fichier);
		$emplacement = sous_repertoire(_DIR_TMP, 'codes_postaux');
		@chmod($emplacement, 0777);
		$nom_fichier = $emplacement . $infos_fichier['filename'] . '.' . $infos_fichier['extension'];

		if ($infos_fichier['extension'] === 'zip') {
			include_spip('inc/joindre_document');
			include_spip('inc/archives');
			$zip = new Spip\Archives\SpipArchives(_DIR_RACINE . $fichier);

			if (!$infos = $zip->informer()) {
				spip_log(
					'charger_decompresser erreur zip ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $quoi['archive'],
					'teleport' . _LOG_ERREUR
				);
				return $zip->message();
			}
			$target = _DIR_TMP;
			if (!$zip->deballer($target)) {
				spip_log(
					'charger_decompresser erreur tar ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $quoi['archive'],
					'teleport' . _LOG_ERREUR
				);
				return $zip->message();
			}
			if (isset($infos['fichiers'][0])) {
				foreach ($infos['fichiers'] as $tFichier) {
					if ($tFichier['filename'] !== "readme.txt"){
						rename( _DIR_TMP.$tFichier['filename'], $emplacement . $nom_fichier_txt);
					}
				}
			}
			unlink(_DIR_RACINE .$fichier);
			return $nom_fichier;
		}
		else{
			rename(_DIR_RACINE . $nom_fichier, $emplacement.$nom_fichier_txt);
			return $nom_fichier;
		}
	}
	return false;
}
